/***************************************************************************
                          cbomb.cpp  -  description
                             -------------------
    begin                : Sat Apr 27 2002
    copyright            : (C) 2002 by funthing (Matthias Zisler)
    email                : matthias@zislers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "cbomb.h"
#include "sprite.h"
#include "timer.h"
#include "resources.h"
#include "explosion.h"
#include "map_sample.h"
#include "player.h"
#include "map.h"
#include "maptile_normal.h"
#include "maptile.h"

Cbomb::Cbomb(int _x, int _y, Map_Sample* _sample) : Effects(_x, _y, _sample)
{
	timer=new Timer;
	sprite=new Sprite(Resources::Tiles(), 0.2f);
	spre=new Sprite(Resources::Tiles(), 0.2f);
	sprite->set_new(0.4f, 32, 35);	
	spre->set_new(0.3f, 44, 48);
  b=false;
}
Cbomb::~Cbomb()
{
}
void Cbomb::act()
{
	if(timer->time_elapsed()>=2.0f)
	{
    if(!b)
    {
		sprite->set_new(10.0f, 35, 35);
    PLAY(Resources::Cbexplode());
    b=true;
    }	

		if(sample->map->get_maptile(map_x(), map_y())->get_type()==NORMAL)
		static_cast <Maptile_normal*> (sample->map->get_maptile(map_x(), map_y()))->dig();

  	for(int i=0; i<=3; i++)
		{
			if(sample->map->get_maptile(map_x()+((i*32)+32), map_y())->get_type()==NORMAL)
			static_cast <Maptile_normal*> (sample->map->get_maptile(map_x()+((i*32)+32), map_y()))->dig();
		
			if(sample->map->get_maptile(map_x()-((i*32)+32), map_y())->get_type()==NORMAL)
			static_cast <Maptile_normal*> (sample->map->get_maptile(map_x()-((i*32)+32), map_y()))->dig();

			sample->kill(map_x()+((i*32)+32), map_y());
			sample->kill(map_x()-((i*32)+32), map_y());
		}
		
		if(timer->time_elapsed()>=3.2f)
		this->set_delme();
	}
}
void Cbomb::show()
{
	sprite->put_screen(x, y);

	if(timer->time_elapsed()>=2.0f)
	{
  	for(int i=0; i<=3; i++)
		{
			spre->put_screen(x+((i*32)+32), y);
			spre->put_screen(x-((i*32)+32), y);
		}
	}
}