/***************************************************************************
                          sprite.h  -  description
                             -------------------
    begin                : Sat Feb 9 2002
    copyright            : (C) 2002 by funthing (Matthias Zisler)
    email                : matthias@zislers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SPRITE_H
#define SPRITE_H
#include "global_types.h"

/**
  *@author funthing (Matthias Zisler)
  */
class Timer;
class CL_Surface;

class Sprite
{
public: 
	Sprite(CL_Surface* _sur, float _speed);
	Sprite(CL_Surface* _sur, float _speed, int _offset, int _max);
	Sprite(CL_Surface* _sur, float _speed, int _offset, int _max, int _start);
	~Sprite();

	void jump_to(int n);
	void set_new(int _offset, int _max);
	void set_new(float _speed, int _offset, int _max);
	void set_new(bool i, float _speed, int _offset, int _max);
	
	void play_once();
	void set_loop(bool o);

	bool is_played();
	int get_fnum();

	void set_speed(float _speed);
	void set_inv(bool i);
	void set_pause(bool p);
	void put_screen(int x, int y);
	void put_screen(int x, int y, float scale_x, float scale_y);

private:

	void anim();

	CL_Surface* sur;
	float speed;
	int spr, spr_n, offset;
	bool pause, inv, loop, played;
	Timer* timer;
};

#endif
